Option Strict Off
Option Explicit On
Module AIOWDM
	Const WDG_ACTION_IGNORE As Short = 0
	Const WDG_ACTION_DISABLE As Short = 1
	Const WDG_ACTION_SOFT_RESTART As Short = 2
	Const WDG_ACTION_MOSTLY_SOFT_RESTART As Short = 4
	Const PCI_WDG_CSM_RATE As Double = 2.08333
	Const P104_WDG_CSM_RATE As Double = 2.08333
	Const ISA_WDG_CSM_RATE As Double = 0.894886
	
	Public Declare Function GetNumCards Lib "AIOWDM"  Alias "VBGetNumCards"() As Integer
	Public Declare Function QueryCardInfo Lib "AIOWDM"  Alias "VBQueryCardInfo"(ByVal Cardnum As Integer, ByRef pDeviceID As Integer, ByRef pBase As Integer, ByRef pNameSize As Integer, ByVal pName As String) As Integer
	Public Declare Function QueryBARBase Lib "AIOWDM"  Alias "VBQueryBARBase"(ByVal Cardnum As Integer, ByVal BARIndex As Integer, ByRef pBase As Integer) As Integer
	Public Declare Function WaitForIRQ Lib "AIOWDM"  Alias "VBWaitForIRQ"(ByVal Cardnum As Integer) As Integer
	Public Declare Function AbortRequest Lib "AIOWDM"  Alias "VBAbortRequest"(ByVal Cardnum As Integer) As Integer
	Public Declare Function CloseCard Lib "AIOWDM"  Alias "VBCloseCard"(ByVal Cardnum As Integer) As Integer
	Public Declare Function COSWaitForIRQ Lib "AIOWDM"  Alias "VBCOSWaitForIRQ"(ByVal Cardnum As Integer, ByVal PPIs As Integer, ByRef pData As Byte) As Integer
	Public Declare Function WDGInit Lib "AIOWDM"  Alias "VBWDGInit"(ByVal Cardnum As Integer) As Integer
	Public Declare Function WDGHandleIRQ Lib "AIOWDM"  Alias "VBWDGHandleIRQ"(ByVal Cardnum As Integer, ByRef Action As Integer) As Integer
	Public Declare Function WDGSetTimeout Lib "AIOWDM"  Alias "VBWDGSetTimeout"(ByVal Cardnum As Integer, ByVal Milliseconds As Double, ByVal MHzClockRate As Double) As Double
	Public Declare Function WDGPet Lib "AIOWDM"  Alias "VBWDGPet"(ByVal Cardnum As Integer) As Integer
	Public Declare Function WDGReadTemp Lib "AIOWDM"  Alias "VBWDGReadTemp"(ByVal Cardnum As Integer) As Double
	Public Declare Function WDGReadStatus Lib "AIOWDM"  Alias "VBWDGReadStatus"(ByVal Cardnum As Integer) As Integer
	Public Declare Function WDGStart Lib "AIOWDM"  Alias "VBWDGStart"(ByVal Cardnum As Integer) As Integer
	Public Declare Function WDGStop Lib "AIOWDM"  Alias "VBWDGStop"(ByVal Cardnum As Integer) As Integer
	Public Declare Function EmergencyReboot Lib "AIOWDM"  Alias "VBEmergencyReboot"() As Integer
	Public Declare Function WDGSetResetDuration Lib "AIOWDM"  Alias "VBWDGSetResetDuration"(ByVal Cardnum As Integer, ByVal Milliseconds As Double, ByVal MHzClockRate As Double) As Double
	
	'8-bit
	Public Declare Function InPortB Lib "AIOWDM"  Alias "VBInPortB"(ByVal Port As Integer) As Short
	Public Declare Function OutPortB Lib "AIOWDM"  Alias "VBOutPortB"(ByVal Port As Integer, ByVal Value As Byte) As Short
	
	'16-bit
	Public Declare Function InPort Lib "AIOWDM"  Alias "VBInPort"(ByVal Port As Integer) As Short
	Public Declare Function OutPort Lib "AIOWDM"  Alias "VBOutPort"(ByVal Port As Integer, ByVal Value As Short) As Short
	
	'32-bit
	Public Declare Function InPortL Lib "AIOWDM"  Alias "VBInPortL"(ByVal Port As Integer) As Integer
	Public Declare Function OutPortL Lib "AIOWDM"  Alias "VBOutPortL"(ByVal Port As Integer, ByVal Value As Integer) As Short
	Public Declare Function InPortDWord Lib "AIOWDM"  Alias "VBInPortDWord"(ByVal Port As Integer) As Integer
	Public Declare Function OutPortDWord Lib "AIOWDM"  Alias "VBOutPortDWord"(ByVal Port As Integer, ByVal Value As Integer) As Short
	
	'8-bit Relative
	Public Declare Function RelInPortB Lib "AIOWDM"  Alias "VBRelInPortB"(ByVal Cardnum As Integer, ByVal Port As Integer) As Short
	Public Declare Function RelOutPortB Lib "AIOWDM"  Alias "VBRelOutPortB"(ByVal Cardnum As Integer, ByVal Port As Integer, ByVal Value As Byte) As Short
	
	'16-bit Relative
	Public Declare Function RelInPort Lib "AIOWDM"  Alias "VBRelInPort"(ByVal Cardnum As Integer, ByVal Port As Integer) As Short
	Public Declare Function RelOutPort Lib "AIOWDM"  Alias "VBRelOutPort"(ByVal Cardnum As Integer, ByVal Port As Integer, ByVal Value As Short) As Short
	
	'32-bit Relative
	Public Declare Function RelInPortL Lib "AIOWDM"  Alias "VBRelInPortL"(ByVal Cardnum As Integer, ByVal Port As Integer) As Integer
	Public Declare Function RelOutPortL Lib "AIOWDM"  Alias "VBRelOutPortL"(ByVal Cardnum As Integer, ByVal Port As Integer, ByRef Value As Integer) As Short
	Public Declare Function RelInPortDWord Lib "AIOWDM"  Alias "VBRelInPortDWord"(ByVal Cardnum As Integer, ByVal Port As Integer) As Integer
	Public Declare Function RelOutPortDWord Lib "AIOWDM"  Alias "VBRelOutPortDWord"(ByVal Cardnum As Integer, ByVal Port As Integer, ByVal Value As Integer) As Short
End Module